#!/usr/bin/env python
#
# Written by David Henningsson, Copyright 2011 Canonical Ltd. 
# Licensed under GPLv2+

# the hda_codec.py file comes from Jaroslav Kysela's hda_analyzer program.
from hda_codec import *
import time

def parseoptions():
    from optparse import OptionParser
    parser = OptionParser()
    parser.add_option("-c", "--card", dest="cardindex", default=0, metavar="CARD",
        help="card index (as can be seen in /proc/asound/cards)")
    parser.add_option("-i", "--codec", dest="codecindex", default=0, metavar="CODEC",
        help="codec index (as can be seen in /proc/asound/cardX/codecY)")
    (options, args) = parser.parse_args()
    return int(options.cardindex), int(options.codecindex)
    
def get_simplecaps(node):
    if node.jack_color_name == 'Unknown':
        return "%s (%s %s)" % (node.jack_type_name, node.jack_location_name, node.jack_location2_name)
    return "%s %s (%s %s)" % (node.jack_color_name, node.jack_type_name, node.jack_location_name, node.jack_location2_name)

cardindex, codecindex = parseoptions()
codec = HDACodec(cardindex, codecindex)
codec.analyze()
for nid in codec.nodes:
    node = codec.get_node(nid)
    if WIDGET_TYPE_IDS[node.wtype] == 'PIN':
        if ((node.defcfg_pincaps >> 30) & 0x03) != 1:
	    if (node.pincaps & 1):
                codec.rw(nid, VERBS['SET_PIN_SENSE'], 0)
                time.sleep(0.01)
            sense = codec.rw(nid, VERBS['GET_PIN_SENSE'], 0)
            if node.defcfg_pincaps & (1 << 8):
                print "Pin 0x%.2x %s: No jack detect capability" % (nid, get_simplecaps(node))
            else:
                if sense & 0x80000000:
                    print "Pin 0x%.2x %s: present = YES   impedance = %d" % (nid, get_simplecaps(node), sense - 0x80000000)
                else:
                    print "Pin 0x%.2x %s: present = No" % (nid, get_simplecaps(node))
